#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-10 10:19   ##
##                                 ##
#################


## Creates new plots automatically for windows, mac and Linux
newgraph<-function(platform=.Platform$GUI)
{
    print(platform)
    if(platform=='Rgui')
    return(windows())
    if(platform=='AQUA')
    return(quartz())
    else
    return(x11())
    }
    
 pause<-function()
 {
    cat('Paused. Pres <Enter> to continue')
    readline()
    invisible()
    
    
    }   
    
    
    house<-read.table('../Text/HPRICE1.txt',header=T)  
    attach(house)
    
    ## Ex 7.1
    housed<-lm(saleprice~aircond)
    print(summary(housed))
    
    dummies<-house[,6:10]
    
    print(summary(dummies))
    
    
    print(cor(dummies))
    
    ## Ex 7.2
    housed2<-lm(saleprice~drive+recroom)
    print(summary(housed2))
    
    ## Ex 7.3
    ## Means of the data based on the dummies, drive first and recroom second
    mm<-aggregate(saleprice,list(drive,recroom),mean)
    colnames(mm)<-c('drive','recroom','Mean')
    print(mm)
   
   
   # print(coef(housed2))
   # cat('House with everything',sum(coef(housed2)),'\nHouse with drive and no recroom',coef(housed2)[1]+coef(housed2)[2],'\nHouse with recroom and no drive',coef(housed2)[1]+coef(housed2)[3],'\nHouse with neither drive nor recroom',coef(housed2)[1])
    
    ## Ex 7.4
    
    ## Max number of possible permutations
    x<-c(0,1)
    y<-expand.grid(x,x,x,x,x)
    colnames(y)<-colnames(dummies)
    cat('\nNumber of Possible combinations of dummies\n')
    print(y)
    
    ## Subsets giving the number of houses with each of the dummies
   dd<- aggregate(saleprice,list(drive,recroom,basement,gas,aircond),length)
   colnames(dd)<-c('drive','recroom','basement','gas','aircon','Number')
    print(dd)

    ### Regression on the dummies
    
    fivedum<-lm(saleprice~drive+recroom+basement+gas+aircond)
    print(summary(fivedum))
    
    ## Examples
    
    fit75<-lm(saleprice~aircond+lotsize)
    print( summary(fit75))
    
    newgraph()
    plot(lotsize,saleprice,xlab='Lot Size',ylab='Sale Price Can D')
    abline(a=coef(fit75)[1],b=coef(fit75)[3],col='red')
    abline(a=coef(fit75)[1]+coef(fit75)[2],b=coef(fit75)[3],col='blue')
    legend('topleft',legend=c('No Air Con','Air Con'),lty=1,col=c('red','blue'))
    
    fit751<-lm(saleprice~drive+recroom+lotsize+bed)
    print(summary(fit751))
    
    ## Ex 7.5
    fit75a<-lm(saleprice~lotsize+bed+bath+stories+drive+recroom+basement+gas+aircond)
    print(summary(fit75a))
    
    ## Ex 7.6
    fit76<-update(fit75a,.~.+drive*bed)
    print(summary(fit76))
    
    detach(house)
    
    