#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-10 10:19   ##
##                                 ##
#################


## Creates new plots automatically for windows, mac and Linux
newgraph<-function(platform=.Platform$GUI)
{
    print(platform)
    if(platform=='Rgui')
    return(windows())
    if(platform=='AQUA')
    return(quartz())
    else
    return(x11())
    }
    
 pause<-function()
 {
    cat('Paused. Pres <Enter> to continue')
    readline()
    invisible()
    
    
    }   

## Function for Simple Distributed Lag    
simpleDL<-function(y,x,l)
    {
    	
        x<-embed(x,(l+1))
        
        y<-y[-(1:l)]
        
        ll<-seq(0,(l))
        
       nn<-paste('t-',ll,sep='')
       colnames(x)<-nn
		out<-lm(y~x)
		return(out)
        
        
        }
    
    
    safety<-read.table('../Text/SAFETY.txt',header=TRUE,sep=',')
    attach(safety)
    
 
        
        
 tab82b<-simpleDL(Losses,Training,4)
 summary(tab82b)
 confint(tab82b,level=0.9)
 
 tab82c<-simpleDL(Losses,Training,2)
 summary(tab82c)
 confint(tab82c,level=0.9)
 
 s<-6:1
 fits<-sapply(s,function(s){summary(simpleDL(Losses,Training,s))$coefficients})
 print(fits)
 detach(safety)
 
 ## Ex 8.3
  educ<-read.table('../Text/EDUC.txt',header=TRUE,sep='\t')
    attach(educ)
 
 s<-10:1
 fits<-sapply(s,function(s){summary(simpleDL(GDPgrowth,EducSpending,s))$coefficients})
 print(fits)
 